### ncache-client
NCache is a 100% open Source in-memory distributed cache. NCache is an extremely fast and linearly scalable distributed cache that caches application data and reduces expensive database trips. Use NCache removes performance bottlenecks related to your data storage and databases and scales your python applications to extreme transaction processing (XTP).
https://www.alachisoft.com/
## Installation

### NCache
NCache python client requires a working NCache cluster to run. This cluster handles the storage and
manipulation of the user data.


### Client

```bash
pip install ncache-client
```

## Features

* Cache Performance, Cache Scalability, Bulk Operations, Indexes
* Get, Add, Insert, Remove, Exists, Clear Cache, Expirations, Lock & Unlock
* Key Based Dependency, File Based Dependency, SQL Dependency, Oracle Dependency
* Publish/Subscribe (Pub/Sub) with Topic, Events with Data, Cached Item Specific Events (onInsert/onRemove), Cache Level Events (Add/Insert/Remove), Continuous Query
* Groups/Subgroups, Tags, Named Tags
* DataStructures : **List**, **Queue**, **Counter**


## Getting Help

You can use the following channels for your questions and development/usage issues:

* [Complete documentation](https://www.alachisoft.com/resources/docs/ncache/prog-guide/)
* [API documentation](https://www.alachisoft.com/resources/docs/)


## Contributing
We encourage any type of contribution in the form of issue reports.

### Issue Reports

For issue reports, please share the following information with us to quickly resolve the problems.

* NCache and the client version that you use
* Environment and architecture information you use like total clients, cluster nodes,Java version, operating system etc.
* Logs and stack traces, if any.
* Detailed description of the steps to reproduce the issue.


#### Testing

In order to test NCache Python client locally, you will need the following:

* Java 9 or later
* NCache Installation

## License

[Alachisoft License](https://www.alachisoft.com/licenses/license.txt).


## Copyright

Copyright (c) 2022, Alachisoft, All Rights Reserved.

Visit [https://www.alachisoft.com/](https://www.alachisoft.com/) for more information.
